Ext.define('DSS.wizard.FavoriteAssitentSelector', {
	extend : 'DSS.component.Base',
	mixins : {
		observable : 'Ext.util.Observable'
	},
	getHeight : function() {
		return 240;
	},
	height : '100%',
	favoriteEditor:null,
	constructor : function(config) {
		
		if (Ext.data.StoreManager.lookup('assistentStore') == null) {
			Ext.create('Ext.data.Store', {
				storeId : 'assistentStore',
				fields : [ 'basedSID', 'dSID', 'type', 'zoneID', 'buttontype', 'order',
				           'sceneNames', 'favoriteConfig', 'internalScreenNumber', 'buttons'],
				proxy : {
					type : 'memory',
					reader : {
						type : 'json',
						root : 'items'
					}
				}
			});
		} else {
			Ext.data.StoreManager.lookup('assistentStore').removeAll();
		}
		
		
		this.favoriteEditor=Ext.create('DSS.addon.ScreenTypeSelectorFavorite',{baseStore:'assistentStore'});
		this.favoriteEditor.setWidth(600);
		Ext.apply(this, {
			items : [this.favoriteEditor ],
			margin: "10 0 0 0",
			height: 350,
			width:640,
			layout: {
				type: 'hbox'
			}
		});
		
		this.callParent(arguments);
	},
	reset : function() {
	},
	isValid : function() {
	},
	setValue : function(oValue,allValues) {	
		if (Ext.data.StoreManager.lookup('assistentStore') == null) {
			Ext.create('Ext.data.Store', {
				storeId : 'assistentStore',
				fields : [ 'basedSID', 'dSID', 'type', 'zoneID', 'buttontype', 'order',
				           'sceneNames', 'favoriteConfig', 'internalScreenNumber', 'buttons'],
				proxy : {
					type : 'memory',
					reader : {
						type : 'json',
						root : 'items'
					}
				}
			});
		} else {
			Ext.data.StoreManager.lookup('assistentStore').removeAll();
		}
		
		for (var sKey in allValues.screenValues.targetStructure){
			Ext.data.StoreManager.lookup('assistentStore').add(allValues.screenValues.targetStructure[sKey]);
		}
		if (oValue==null)
			oValue={};
		this.favoriteEditor.dssEditor={editControls:{basedSID:{getValue:function() {return allValues.baseValues.baseDSID}}}};
		var baseDSID=allValues.baseValues.baseDSID;
		for (var iIndex=0;iIndex<Ext.data.StoreManager.lookup('thanosStore').count();iIndex++) {
			var record=Ext.data.StoreManager.lookup('thanosStore').getAt(iIndex);
			if (record.get('dSID')=="-1")
				if (record.get('basedSID')==baseDSID) {
					var oldFavConfig=record.get('favoriteConfig');
					var screenNumbersToRetain=[];
					for (var jIndex=0;jIndex<allValues.screenValues.maintainedScreens.length;jIndex++) {
						var oMaintained=allValues.screenValues.maintainedScreens[jIndex];
						for (var kIndex=0;kIndex<Ext.data.StoreManager.lookup('thanosStore').count();kIndex++) {
							var recordScreen=Ext.data.StoreManager.lookup('thanosStore').getAt(kIndex);
							if (recordScreen.get('basedSID')==baseDSID) 
								if (recordScreen.get('zoneID')==oMaintained.zone) {
									screenNumbersToRetain.push(recordScreen.get('internalScreenNumber'));
								}
						}
					}
					for (var sKey in oldFavConfig) {
						oValue[sKey]={ screen: 15,
								  button: 15,
								  type:0,
								  name: "Favorite " + (parseInt("" + sKey,10) +1)  + "  "};
						for (var jIndex=0;jIndex<screenNumbersToRetain.length;jIndex++)
							if (oldFavConfig[sKey].screen==screenNumbersToRetain[jIndex]) {
								oValue[sKey]=oldFavConfig[sKey];
							}
					}
				}
		}
		this.favoriteEditor.setValue(oValue);
	},
	getValue : function() {
		return this.favoriteEditor.getValue();
	}
});